<?php
//TITLE=English to romaji converter

$outset= 'euc-jp';
$title = 'English to romaji converter';
$progname = 'deeng';

ob_start();?>

<div style="font-size:120%">

<form method=GET action="http://oktober.stc.cx/source/deeng.html">
 Type here your english and press enter:<br>
 <input type=text size=30 name=engtext value="<?=htmlspecialchars($engtext)?>"><br>
 <small>Hint: Use two spaces if you don't want the words glued together
  (usually no recommended: you don't keep pauses in speech between words either).</small>
</form>

<?
if($engtext)
{
  function deeng_shellfix($s){return "'".str_replace("'", "'\''", $s)."'";}
  exec('/usr/local/bin/deeng -p '.deeng_shellfix($engtext).' 2>&1', $tmp);
  $phon = $tmp[0];
  $roma = $tmp[1];
  echo 'Here is your romaji (<small>derived from <em>', htmlspecialchars($phon), '</em></small>):<pre>',
    htmlspecialchars(
      str_replace(array('a^','i^','o^','u^','e^','^'),
                  array('aa','ii','oh' ,'uu','ee','~'),
                  $roma)),
    '</pre>';
  if(file_exists('/root/src/kr2kb.sed'))
  {
    echo 'This is it in HIRAGANA: ';
    $res = exec('echo '.deeng_shellfix($roma).'|sed -f /root/src/kr2kb.sed|/usr/local/bin/htmlrecode -Ieucjp -Oiso-8859-1');
    print str_replace('^', '&#x30FC;', $res);
  }
  if(file_exists('/root/src/rom2kat.sed'))
  {
    echo '<br>This is it in KATAKANA: ';
    $res = exec('echo '.deeng_shellfix($roma).'|sed -f /root/src/rom2kat.sed|/usr/local/bin/htmlrecode -Ieucjp -Oiso-8859-1');
    print str_replace('^', '&#x30FC;', $res);
  }
}

?>
</div>

<?$demo=ob_get_contents();
ob_end_clean();

$text = array(
   '1. Purpose' => "

This program converts english words, names and sentences to romaji
by transforming them to phonemes and then converting the phonemes
to romaji.<br>
Romaji (&#12525;&#12540;&#12510;&#23383;) is the romanization
(transliteration to latin characters) of the japanese writing.<br>
This page therefore contains an english to japanese writing -converter.

", '1. Online demo' => "

$demo
NOTE: This is neither a translator nor a <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>!
<br>It only converts between different writing methods!
<p>
Sorry, I do not have a reverse
converter (katakana to english) here.<br>
But I do have a <a href=\"http://kanjidict.stc.cx/kakasifilt.php\">kana and kanji to romaji filter</a>.
<p>
If you want to convert romaji to english, try looking the words up
from a <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>.

", '1.1. Funny' => "

Tuesday 19th November 2002, I happened to browse my access log...<br>
Here are some queries people have tried today:

<pre class=smallerpre>
alb-66-66-228-239.nycap.rr.com - - [19/Nov/2002:00:19:04 +0200] \"How   are  you\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:02:56:04 +0200] \"Friday\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:02:32 +0200] \"School\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:04:52 +0200] \"Sunday\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:05:31 +0200] \"Monday\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:06:26 +0200] \"Tuesday\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:08:32 +0200] \"Saturday\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:16:40 +0200] \"good morning\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:17:43 +0200] \"wake up\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:19:46 +0200] \"breakfast\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:20:28 +0200] \"walk  on  the  beach\"
prx5.qld2.schools.net.au       - - [19/Nov/2002:03:20:51 +0200] \"walk on the beach\"
filterproxy2.syd.ozemail.net   - - [19/Nov/2002:04:18:32 +0200] \"kyle  is  a  fag\"
filterproxy1.syd.ozemail.net   - - [19/Nov/2002:04:19:19 +0200] \"mrs  hartman  is  gay\"
host154-45.student.udel.edu    - - [19/Nov/2002:05:57:57 +0200] \"Look at the blue sky.\"
host154-45.student.udel.edu    - - [19/Nov/2002:05:58:17 +0200] \"Look at the blue sky.\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:54:12 +0200] \"accidents...the product of human evolution\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:54:52 +0200] \"accidents...the  product  of  human  evolution\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:55:21 +0200] \"death  to  democracy\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:55:41 +0200] \"down   with   democracy\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:55:50 +0200] \"democracy\"
nat140-82.mpoweredpc.net       - - [19/Nov/2002:14:56:07 +0200] \"death   to   democracy\"
</pre>

You must try hard if you want to supplement this list ;)

", '1. Copying' => "

deeng has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).
<p>
The English to phonemes tables and code were directly
copied from the public domain rsynth-2.0 project (speech synthesizer),
which copies the data from a publication from 1976.

", '1. Quality notes' => "

Phoneme code to romaji conversion is based on a direct conversion
with no dictionary, so you might get different results than when
looking at your <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>.
<p>
The conversion program is quite logical and straightforward.<br>
English isn't. Therefore the results might not be the best quality.
An example of poorly converted word is \"what\".

", '1. Requirements' => "

GNU make is required.<br>

");
include '/WWW/progdesc.php';
